<?php

if(_SERVER("REQUEST_METHOD"))
	exit; // avoid php execution via http request

include_once "/lib/sd_340.php";

/* Definition for AI Port */
define("AI_NUMBER",     4);

/* Setup AI Ports */
for($port=0; $port<AI_NUMBER; $port++)
{
	uio_setup(0, 16+$port, "out_pp low");  /* for 0~5V Mode */
	//uio_setup(0, 16+$port, "out_pp high"); /* for 0~20mA or 4~20mA Mode */
}
$adc_pid = pid_open("/mmap/adc0");
pid_ioctl($adc_pid, "set ch 0 1 2 3");
pid_close($adc_pid);

sleep(1);

for(;;)
{
	/* Load ADC Value */
	$adc_rbuf = "";
	$adc_pid = pid_open("/mmap/adc0");
	pid_read($adc_pid, $adc_rbuf, 8);
	pid_close($adc_pid);

	/* Update AI Port Status */
	$ai_val = 0;
	for($port=0; $port<AI_NUMBER; $port++)
	{
		$ai_val = bin2int($adc_rbuf, $port<<1, 2); /* for 0~5V Mode */
		/* for 4~20mA MODE
		if($ai_val > 819)
		{
			$ai_val -= 819;
			if(($ai_val & 0x03) >= 2)
				$round = 1;
			else
				$round = 0;
			$ai_val += ($ai_val >> 2);
			$ai_val += $round;
		}
		*/

		echo "AI$port - $ai_val\r\n";
	}

	sleep(5);
}

?>
